%define _gnu		%{nil}
%define	_smp_mflags	-j1

Summary:	A GNU collection of binary utilities.
Name:		binutils
Group:		Development/Tools
License:	GPL
Version:	2.16.91.0.3
Release:	2
Source0:	ftp://ftp.kernel.org/pub/linux/devel/binutils/binutils-%{version}.tar.gz
Buildroot:	%{_tmppath}/%{name}-%{release}-root
BuildRequires:	texinfo >= 4.0, gettext

%description
Binutils is a collection of binary utilities, including ar (for
creating, modifying and extracting from archives), as (a family of GNU
assemblers), gprof (for displaying call graph profile data), ld (the
GNU linker), nm (for listing symbols from object files), objcopy (for
copying and translating object files), objdump (for displaying
information from object files), ranlib (for generating an index for
the contents of an archive), size (for listing the section sizes of an
object or archive file), strings (for listing printable strings from
files), strip (for discarding symbols), and addr2line (for converting
addresses to file and line).

%files -f %{name}.lang
  %defattr(-,root,root)
  %doc README
  %{_prefix}/bin/*
  %{_mandir}/man1/*
  %{_prefix}/include/*
  %{_prefix}/%{_lib}/lib*
  %{_infodir}/*info*

%prep
%setup -q
  # libtool sucks
  perl -pi -e 'm/LIBADD/ && s/(\.\.\/bfd\/libbfd.la)/-L\.\.\/bfd\/\.libs \1/' opcodes/Makefile.{am,in}
  # LTP sucks
  perl -pi -e 's/i\[3-7\]86/i[34567]86/g' */conf*
  touch */configure

%build
  mkdir build-%{_target_platform}
  cd build-%{_target_platform}
  CARGS=
  CFLAGS="${CFLAGS:-%optflags}" ../configure \
    %{_target_platform} --prefix=%{_prefix} --exec-prefix=%{_exec_prefix} \
    --bindir=%{_bindir} --sbindir=%{_sbindir} --sysconfdir=%{_sysconfdir} \
    --datadir=%{_datadir} --includedir=%{_includedir} --libdir=%{_libdir} \
    --libexecdir=%{_libexecdir} --localstatedir=%{_localstatedir} \
    --sharedstatedir=%{_sharedstatedir} --mandir=%{_mandir} \
    --infodir=%{_infodir} --enable-shared $CARGS
  make %{_smp_mflags} tooldir=%{_prefix} all info
  echo ====================TESTING=========================
  make -k check || :
  echo ====================TESTING END=====================
  cd ..

%install
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

  mkdir -p %{buildroot}%{_prefix}
  pushd build-%{_target_platform}
  %makeinstall

  # Rebuild libiberty.a with -fPIC
  make -C libiberty clean
  make CFLAGS="-g -fPIC $RPM_OPT_FLAGS" -C libiberty

  install -m 644 libiberty/libiberty.a %{buildroot}%{_prefix}/%{_lib}
  install -m 644 ../include/libiberty.h %{buildroot}%{_prefix}/include
  # Remove Windows/Novell only man pages
  rm -f %{buildroot}%{_mandir}/man1/{dlltool,nlmconv,windres}*

  chmod +x %{buildroot}%{_prefix}/%{_lib}/lib*.so*

  # Prevent programs to link against libbfd and libopcodes dynamically,
  # they are changing far too often
  rm -f %{buildroot}%{_prefix}/%{_lib}/lib{bfd,opcodes}.so

  # This one comes from gcc
  rm -f %{buildroot}%{_prefix}/bin/c++filt
  rm -f %{buildroot}%{_infodir}/dir
  rm -rf %{buildroot}%{_prefix}/%{_target_platform}

  popd

  %find_lang binutils
  %find_lang opcodes
  %find_lang bfd
  %find_lang gas
  %find_lang ld
  %find_lang gprof
  for i in opcodes bfd gas ld gprof
  do
    cat $i.lang >> binutils.lang
  done

%post   -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%clean
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%changelog
* Thu Aug 25 2005 Peter O'Hara <pete@guardiandigital.com>
- Version 2.16.91.0.3, Release 2
  - Upgraded to the latest release

* Tue Jun 28 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 2.16.91.0.1, Release 1
  - Initial build for EnGarde Secure Linux 3.0.
